# Create a service account. POST https://app.unleash-instance.example.com/api/admin/service-account Content-Type: application/json **Enterprise feature** Creates a new service account. Reference: https://docs.getunleash.io/api/create-service-account ## OpenAPI Specification ```yaml openapi: 3.1.1 info: title: Create a service account. version: endpoint_serviceAccounts.createServiceAccount paths: /api/admin/service-account: post: operationId: create-service-account summary: Create a service account. description: |- **Enterprise feature** Creates a new service account. tags: - - subpackage_serviceAccounts parameters: - name: Authorization in: header description: Header authentication of the form `undefined ` required: true schema: type: string responses: '201': description: The resource was successfully created. content: application/json: schema: $ref: '#/components/schemas/serviceAccountSchema' '400': description: The request data does not match what we expect. content: {} '401': description: >- Authorization information is missing or invalid. Provide a valid API token as the `authorization` header, e.g. `authorization:*.*.my-admin-token`. content: {} '403': description: >- The provided user credentials are valid, but the user does not have the necessary permissions to perform this operation content: {} '409': description: >- The provided resource can not be created or updated because it would conflict with the current state of the resource or with an already existing resource, respectively. content: {} '415': description: >- The operation does not support request payloads of the provided type. Please ensure that you're using one of the listed payload types and that you have specified the right content type in the "content-type" header. content: {} requestBody: description: '#/components/schemas/createServiceAccountSchema' content: application/json: schema: $ref: '#/components/schemas/createServiceAccountSchema' components: schemas: createServiceAccountSchema: type: object properties: username: type: string description: The username of the service account name: type: string description: The name of the service account rootRole: type: integer description: The id of the root role for the service account required: - username - name - rootRole patSchema: type: object properties: id: type: integer description: >- The PAT's ID. PAT IDs are incrementing integers. In other words, a more recently created PAT will always have a higher ID than an older one. secret: type: string description: >- The token used for authentication. It is automatically generated by Unleash when the PAT is created and that is the only time this property is returned. createdAt: type: string format: date-time description: The date and time of when the PAT was created. seenAt: type: - string - 'null' format: date-time description: >- When the PAT was last seen/used to authenticate with. `null` if it has not been used yet. userId: type: integer description: The ID of the user this PAT belongs to. description: type: string description: The PAT's description. expiresAt: type: string format: date-time description: The PAT's expiration date. required: - id - createdAt - description - expiresAt serviceAccountSchema: type: object properties: id: type: number format: double description: The service account id isAPI: type: boolean description: >- Deprecated: for internal use only, should not be exposed through the API name: type: string description: The name of the service account email: type: string description: 'Deprecated: service accounts don''t have emails associated with them' username: type: string description: The service account username imageUrl: type: string description: The service account image url inviteLink: type: string description: >- Deprecated: service accounts cannot be invited via an invitation link loginAttempts: type: number format: double description: 'Deprecated: service accounts cannot log in to Unleash' emailSent: type: boolean description: 'Deprecated: internal use only' rootRole: type: integer description: The root role id associated with the service account seenAt: type: - string - 'null' format: date-time description: >- Deprecated. This property is always `null`. To find out when a service account was last seen, check its `tokens` list and refer to each token's `lastSeen` property instead. createdAt: type: string format: date-time description: The service account creation date tokens: type: array items: $ref: '#/components/schemas/patSchema' description: The list of tokens associated with the service account required: - id ``` ## SDK Code Examples ```python import requests url = "https://app.unleash-instance.example.com/api/admin/service-account" payload = { "username": "service-account-1", "name": "Service Account 1", "rootRole": 1 } headers = { "Authorization": "", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://app.unleash-instance.example.com/api/admin/service-account'; const options = { method: 'POST', headers: {Authorization: '', 'Content-Type': 'application/json'}, body: '{"username":"service-account-1","name":"Service Account 1","rootRole":1}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://app.unleash-instance.example.com/api/admin/service-account" payload := strings.NewReader("{\n \"username\": \"service-account-1\",\n \"name\": \"Service Account 1\",\n \"rootRole\": 1\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://app.unleash-instance.example.com/api/admin/service-account") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = '' request["Content-Type"] = 'application/json' request.body = "{\n \"username\": \"service-account-1\",\n \"name\": \"Service Account 1\",\n \"rootRole\": 1\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://app.unleash-instance.example.com/api/admin/service-account") .header("Authorization", "") .header("Content-Type", "application/json") .body("{\n \"username\": \"service-account-1\",\n \"name\": \"Service Account 1\",\n \"rootRole\": 1\n}") .asString(); ``` ```php request('POST', 'https://app.unleash-instance.example.com/api/admin/service-account', [ 'body' => '{ "username": "service-account-1", "name": "Service Account 1", "rootRole": 1 }', 'headers' => [ 'Authorization' => '', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://app.unleash-instance.example.com/api/admin/service-account"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", ""); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"username\": \"service-account-1\",\n \"name\": \"Service Account 1\",\n \"rootRole\": 1\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "", "Content-Type": "application/json" ] let parameters = [ "username": "service-account-1", "name": "Service Account 1", "rootRole": 1 ] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://app.unleash-instance.example.com/api/admin/service-account")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```